/*
 * @Descripttion: uf_file operate read write
 * @version: 0.0.1
 * @Author: dyb
 * @Date: 2021-04-28 14:59:55
 * @LastEditors: sueRimn
 * @LastEditTime: 2021-04-28 16:12:18
 */
#ifndef __APP_UF_DB_H__
#define __APP_UF_DB_H__

#include "tuya_cloud_types.h"
#ifndef NEW_SDK
#include "uf_file.h" // 2.3.1的sdk
#else
#include "tuya_uf_db.h" // 2.3.2以后的sdk
#endif // !NEW_SDK

#ifdef __cplusplus
extern "C" {
#endif

#ifdef  __APP_UF_DB_GLOBALS
    #define __APP_UF_DB_EXT
#else
    #define __APP_UF_DB_EXT extern
#endif

/**
 * @brief tuya_adapt_uf_read
 *        uf file读取配置
 * @param filename 文件名
 * @param len 长度
 * @param data 读取的数据
 * @return OPERATE_RET
 */
__APP_UF_DB_EXT \
OPERATE_RET tuya_adapt_uf_read(IN CHAR_T *filename, IN USHORT_T len, OUT UCHAR_T *data);

/**
 * @brief tuya_adapt_uf_write
 *        uf file写配置
 * @param filename 文件名
 * @param len 长度
 * @param data 读取的数据
 * @return OPERATE_RET
 */
__APP_UF_DB_EXT \
OPERATE_RET tuya_adapt_uf_write(IN CHAR_T *filename, IN UCHAR_T *data, IN USHORT_T len);



/**
 * @brief tuya_adapt_uf_delete
 *        uf file删除文件
 * @param filename 文件名
 * @return OPERATE_RET
 */
__APP_UF_DB_EXT \
OPERATE_RET tuya_adapt_uf_delete(IN CHAR_T *filename);

#ifdef __cplusplus
} // extern "C"
#endif

#endif //

