/***********************************************************
*  File: dp_timer_basic.h
*  Author: sandra
*  Date: 20190402
*  Description:
*       modified by wqp
***********************************************************/
#ifndef DPTM_BASIC_H
#define DPTM_BASIC_H

#include "tuya_cloud_types.h"

#ifdef __cplusplus
    extern "C" {
#endif

#ifdef _DPTM_BASIC_GLOBAL
    #define _DPTM_BASIC_EXT 
#else
    #define _DPTM_BASIC_EXT extern
#endif

/***********************************************************
***********************typedef define***********************
***********************************************************/
typedef PVOID_T    DPTM_HANDLE;

/*DP(raw)
序号：#1控制（bit0--开关，bit7-bit1---通道号）/#2星期/#3#4起始时间(min)/#5#6结束时间(min)
代表星期的字节按位表示如下：
00: 单次 01：周日 02：周一 04：周二 08：周三 10：周四 20：周五 40：周六*/

#pragma pack(1)

typedef struct{
    UCHAR_T      active:   1;
    UCHAR_T      ch_idx:   7;
}tTIMER_CTRL;

typedef struct{
    tTIMER_CTRL  ctrl;
    UCHAR_T      week;
    USHORT_T     start_time;
    USHORT_T     end_time;
    UCHAR_T      ext_da[0];
}tDPTM;

#pragma pack()

typedef BOOL_T (*ConvDataToTm)(IN UCHAR_T *pdata, IN UINT_T prot_len, OUT tDPTM *node_tm, IN UINT_T dptm_len);
typedef BOOL_T (*ConvTmToData)(IN tDPTM *node_tm, IN UINT_T dptm_len, OUT UCHAR_T *pdata, IN UINT_T prot_len);
typedef VOID   (*TimePiontProce)(CONST IN tDPTM *node_tm, IN UINT_T dptm_len, IN BOOL_T is_start_tm);
typedef VOID   (*TimeSync)(VOID);


typedef struct{
    ConvDataToTm    conv_data_tm_cb;
    ConvTmToData    conv_tm_data_cb;
    TimePiontProce  time_point_proc_cb;
    TimeSync        time_sync_cb;
}tDPTM_CBS;

/***********************************************************
*   Function:   dptm_init
*   Input:      none
*   Output:     none
*   Return:     none
*   Notice:     dptm_init
***********************************************************/
_DPTM_BASIC_EXT \
OPERATE_RET dptm_init(VOID);

/***********************************************************
*   Function:   dp_timer_basic_init
*   Input:      dptm_len
*               prot_len
*               tm_cbs
*               handle
*   Output:     OPERATE_RET
*   Return:     OPERATE_RET
*   Notice:     dptm_create_handle
***********************************************************/
_DPTM_BASIC_EXT \
OPERATE_RET dp_tm_create_handle(IN UINT_T tm_len, IN UINT_T unit_len, \
                                     IN tDPTM_CBS *tm_cbs, OUT DPTM_HANDLE *handle);

/***********************************************************
*   Function:   dptmt_timing_tm_update
*   Input:      tm_handle
*   Output:     none
*   Return:     none
*   Notice: dptmt_timing_tm_update
***********************************************************/
_DPTM_BASIC_EXT \
VOID dptmt_timing_tm_update(IN DPTM_HANDLE tm_handle);

#ifdef __cplusplus
}
#endif

#endif /*DPTM_BASIC_H*/
