/***********************************************************
*  File: tuya_timer.h
*  Author: sandra
*  Date: 20190402
*  Description:
*       modified by wqp
***********************************************************/
#ifndef TUYA_TIMER_H
#define TUYA_TIMER_H

#include "tuya_cloud_types.h"
#include "dptm_basic.h"

#ifdef __cplusplus
    extern "C" {
#endif

#ifdef _TUYA_TIMER_GLOBAL
    #define _TUYA_TIMER_EXT 
#else
    #define _TUYA_TIMER_EXT extern
#endif


/***********************************************************
*************************micro define***********************
***********************************************************/
#define INVALID_TYPE                0xFF
#define TY_TM_TYPE_MAX              3
#define CH_NUM_MAX                  7

/***********************************************************
***********************typedef define***********************
***********************************************************/
typedef UCHAR_T TUYA_TIME_TYPE_E;
#define TY_TM_TYPE_NML              0x00
#define TY_TM_TYPE_RND              0x01
#define TY_TM_TYPE_CYCLE            0x02

typedef struct {
    TUYA_TIME_TYPE_E  type;
    INT_T           dp;
}tTIME_DP;

typedef VOID (*TimerProceCB)(IN UCHAR_T ch, IN BOOL_T state, IN TUYA_TIME_TYPE_E dp_type);


/***********************************************************
*   Function:   tuya_dp_timer_init
*   Input:      tm_list    dpid lsit
*               tm_num     time num
*               ch_num     channel num max
*               proce_cb   timeout process callback
*   Output:     none
*   Return:     OPERATE_RET
*   Notice:     tuya_dp_timer_init
***********************************************************/
_TUYA_TIMER_EXT \
OPERATE_RET tuya_dp_timer_init(IN tTIME_DP *tm_list, IN UINT_T tm_num, IN UINT_T ch_num, \
                                     IN TimerProceCB proce_cb);

/***********************************************************
*   Function:   tuya_time_erase_all
*   Input:      none
*   Output:     none
*   Return:     none
*   Notice:     tuya_time_erase_all
***********************************************************/
_TUYA_TIMER_EXT \
VOID tuya_time_erase_all(VOID);

/***********************************************************
*   Function:   tuya_time_erase
*   Input:      type:time type
*   Output:     none
*   Return:     none
*   Notice:     tuya_time_erase
***********************************************************/
_TUYA_TIMER_EXT \
VOID tuya_time_erase(IN TUYA_TIME_TYPE_E type);

/***********************************************************
*   Function:   tuya_time_uplaod
*   Input:      type:time type
*   Output:     none
*   Return:     none
*   Notice:     tuya_time_uplaod
***********************************************************/
_TUYA_TIMER_EXT \
VOID tuya_time_uplaod(IN TUYA_TIME_TYPE_E type);

/***********************************************************
*   Function:   tuya_time_uplaod_all
*   Input:      none
*   Output:     none
*   Return:     none
*   Notice:     tuya_time_uplaod_all
***********************************************************/
_TUYA_TIMER_EXT \
VOID tuya_time_uplaod_all(VOID);

/***********************************************************
*   Function:  tuya_time_proc_tm_str
*   Input:     dpid    timer dpid
*               pstr    time data (string)
*   Output:     none
*   Return:     none
*   Notice:     tuya_time_proc_tm_str
***********************************************************/
_TUYA_TIMER_EXT \
VOID tuya_time_proc_tm_str(IN UINT_T dpid, IN PCHAR_T pstr);

#ifdef __cplusplus
}
#endif

#endif /*TUYA_TIMER_H*/


